#!/usr/bin/perl -w

use strict;
use warnings;
use LWP 5.64;

require "/usr/bin/rnagios-plug.pl";

#Konfiguration:
my @config=();
open(DATEI, "</etc/remote-nagios/rnagios.conf") || die "Konfigurationsdatei nicht gefunden";
push(@config,<DATEI>);
close(DATEI);


my $configline="";
my $key="";
my $value="";
my %configuration=();

foreach $configline (@config) {
 
 if ($configline!~ /^(#.*|[\s]*)$/){
  chomp($configline);
  $configline =~ s/\s+//;
  ($key,$value) = split (/=/, $configline);
  chomp($key);
  chomp($value);

  $configuration{"$key"}=$value;
 }
}


my $sendipaddress=$configuration{"sendipaddress"};
my $hostip=$configuration{"hostip"};
my $hostname=$configuration{"hostname"};

my $username=$configuration{"username"};
my $password=$configuration{"password"};
my $realmname=$configuration{"realmname"};
my $servername=$configuration{"servername"};
my $portnumber=$configuration{"portnumber"};
my $url = $configuration{"url"};
             

my $servicename;
my @plugins=pluginsauslesen();
my $plugin;

my $i=0;
my $line="";

print"
define host{
	use                     generic-host            ; Name of host template to use
	host_name               $hostname 
	alias                   $hostname
	address                	$hostip 
}
";

foreach $line (@plugins) {
 
 my $testname=$plugins[$i]{"name"};
 
 my @vars=split (/\!/, $testname);
 my $servicename=$vars[0];
 $servicename=~ s/check_|check-//;
 
print "
define service{
	use                             remote-nagios-service         ; Name of service template to use
	host_name                       $hostname
	service_description             $servicename
	check_command                   return-unknown
}
\n";



$i++;
}

